Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2481 by niro, Wed Jan 8 10:27:55 2014 UTC revision 2889 by niro, Fri Jul 31 10:55:16 2015 UTC
# Line 9  Line 9 
9    
10  # setup locales  # setup locales
11  TEXTDOMAIN=installer  TEXTDOMAIN=installer
 LC_MESSAGES=C  
12    
13  # include dir  # include dir
14  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
# Line 41  do Line 40  do
40   fi   fi
41  done  done
42    
 # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  
 # -> now in images.conf  
 CDIMAGENAME=""  
 TOTALLINES=""  
 CURRENTLINE=0  
 if [ -e /mnt/cdrom/system/images.conf ]  
 then  
  source /mnt/cdrom/system/images.conf  
  # check if all required variables are set  
  [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"  
  [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"  
 else  
  die "/mnt/cdrom/system/images.conf not found"  
 fi  
   
43  ### System/Config Version  ### System/Config Version
44  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
45  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
46    
47  # some sane defaults  # some sane defaults
48  CDROOT="${DEFAULT_CDROOT}"  LIVEROOT="${DEFAULT_LIVEROOT}"
49    IMAGEROOT="${DEFAULT_IMAGEROOT}"
50  INSTALLROOT="${DEFAULT_INSTALLROOT}"  INSTALLROOT="${DEFAULT_INSTALLROOT}"
51  KERNELPKG="${DEFAULT_KERNELPKG}"  KERNELPKG="${DEFAULT_KERNELPKG}"
52  KERNELOPTS="${DEFAULT_KERNELOPTS}"  KERNELOPTS="${DEFAULT_KERNELOPTS}"
# Line 72  SPECIALDEVICE="" Line 57  SPECIALDEVICE=""
57  FORMFACTOR="${DEFAULT_FORMFACTOR}"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
58  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
59    
60  #################################################  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
61  #  DIALOG BOXEN #  # -> now in images.conf
62  #################################################  CDIMAGENAME=""
63    TOTALLINES=""
64    CURRENTLINE=0
65    if [ -e ${IMAGEROOT}/images.conf ]
66    then
67     source ${IMAGEROOT}/images.conf
68     # check if all required variables are set
69     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in ${IMAGEROOT}/images.conf"
70     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in ${IMAGEROOT}/images.conf"
71    else
72     die "${IMAGEROOT}/images.conf not found"
73    fi
74    
75    ### helper scripts ###
76    
77  trap_exit()  trap_exit()
78  {  {
# Line 83  trap_exit() Line 81  trap_exit()
81   is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys   is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
82   is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot   is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
83   is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}   is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
84     [[ -n ${SWAPHDD} ]] && swapoff ${SWAPHDD}
85    
86   echo $"Installation aborted."   echo $"Installation aborted."
87   exit 1   exit 1
88  }  }
89    
90  dialog_die()  install_meter()
 {  
  ERROR="$1"  
  RETVAL="$?"  
  dialog_install_failure  
  exit 1  
 }  
   
 dialog_warning()  
91  {  {
92   local retval   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
93     do
94   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"   CURRENTLINE=$(grep -c . /tmp/install.log)
95   retval=$?   PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))
96   if [[ ${retval} -eq 1 ]]   echo ${PERCENT}
97   then   sleep 1
98   clear   done
99   echo $"The process was aborted."   rm -f /tmp/install.log
100   exit 1   return 0
  fi  
101  }  }
102    
103  task_setup_system_menu()  mount_rootfs()
104  {  {
  local mode  
105   local retval   local retval
106    
107   mode="$(dialog_setup_system_menu)"   if [[ -n ${SWAPHDD} ]]
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
108   then   then
109   case "${mode}" in   swapon ${SWAPHDD} || dialog_die $"Could not enable swap space '${SWAPHDD}'"
  "1") run_install_auto ;;  
  "2") run_install_normal ;;  
  "") task_setup_system_menu;;  
  esac  
  fi  
 }  
   
 task_hardware_detection()  
 {  
  local message  
   
  run_hardware_detection_disks  
   
  message+=$"Harddrives:\n"  
   
  if [[ ! -z ${ALL_DISKS} ]]  
  then  
  for i in ${ALL_DISKS}  
  do  
  message+="\Z3${i}\Zn "  
  done  
  message+="\n"  
  fi  
   
  if [[ ! -z ${ALL_CDROMS} ]]  
  then  
  message+="\n"  
  message+=$"Optical disk drives:\n"  
  for i in ${ALL_CDROMS}  
  do  
  message+="\Z3${i}\Zn"  
  done  
  message+="\n"  
110   fi   fi
111    
112   # other devices   if [[ -n ${ROOTHDD} ]]
  run_hardware_detection  
  case "${SPECIALDEVICE}" in  
  zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;  
  rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;  
  maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;  
  *) message+=$"\n\ZnCommon device detected.\Zn" ;;  
  esac  
  if [[ ${FORMFACTOR} = laptop ]]  
113   then   then
114   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"   if is_mounted --location "${INSTALLROOT}"
115     then
116     echo $"${INSTALLROOT} already mounted" >&2
117     else
118     mount -t "${FORMAT_FILESYSTEM_ROOTHDD}" "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive '${ROOTHDD}' -> '${INSTALLROOT}'"
119     fi
120   fi   fi
121    
122   messagebox -y 12 -h $"Detected hardware:" "${message}"   [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot
 }  
123    
124  task_setup_hdd_partitions_manual()   if [[ -n ${BOOTHDD} ]]
 {  
  local i  
  local retval  
   
  if [[ -z ${ALL_DISKS} ]]  
125   then   then
126   dialog_no_harddrive_found   if is_mounted --location "${INSTALLROOT}"/boot
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
127   then   then
128   dialog_setup_hdd_info   echo $"${INSTALLROOT}/boot already mounted" >&2
129   setup_hdd_partitions_manual   else
130     mount -t "${FORMAT_FILESYSTEM_BOOTHDD}" "${BOOTHDD}" "${INSTALLROOT}"/boot || dialog_die $"Could not mount bootfs - drive '${BOOTHDD}' -> '${INSTALLROOT}/boot'"
131   fi   fi
132   fi   fi
133  }  }
134    
135  task_setup_hdd_partitions_auto()  umount_rootfs()
136  {  {
137   local i   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
138   local retval   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
139    
140   if [[ -z ${ALL_DISKS} ]]   if [[ -n ${SWAPHDD} ]]
141   then   then
142   dialog_no_harddrive_found   swapoff ${SWAPHDD} || die
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
143   fi   fi
144  }  }
145    
146  install_meter()  install_do_reboot()
 {  
  while [[ ${CURRENTLINE} != ${TOTALLINES} ]]  
  do  
  CURRENTLINE=$(grep -c . /tmp/install.log)  
  PERCENT=$(( ${CURRENTLINE} * 100 / ${TOTALLINES}))  
  echo ${PERCENT}  
  sleep 1  
  done  
  rm -f /tmp/install.log  
  return 0  
 }  
   
 task_main()  
147  {  {
148   local method=0   reboot
  local retval  
   
  while [[ ${method} -le 2 ]]  
  do  
  method=$(dialog_main)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && exit 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  case ${method} in  
  "1") task_setup_system_menu ;;  
  "2") task_hardware_detection ;;  
  "3") install_do_reboot ;;  
  "4") /bin/bash --login -i ;;  
  esac  
  fi  
  done  
149  }  }
150    
 #################################################  
 # Install Komandos #  
 #################################################  
151  run_hardware_detection()  run_hardware_detection()
152  {  {
153   local hwinfo   local hwinfo
154    
155   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
156    
157   ## check for special devices/clients:   # check for special devices/clients:
158   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
159   #local removable=0   local removable=0
160   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
161   #then   then
162   #for i in /sys/block/[hs]d*/removable   #for i in /sys/block/[hs]d*/removable
163   #do   #do
164   #if [[ $(< ${i}) = 1 ]]   # if [[ $(< ${i}) = 1 ]]
165   #then   # then
166   #removable=1   # removable=1
167   #fi   # fi
168   #done   #done
169   ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'   # smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
170    
171   ## only add this for grub legacy, grub2 detect these settings on its own   # only add this for grub legacy, grub2 detect these settings on its own
172   #export GRUBLEGACYOPTS="rootdelay=8"   export GRUBLEGACYOPTS="rootdelay=8"
173   ## there are to zotac types in the wild, nvidia based gfx and intel   # there are to zotac types in the wild, nvidia based gfx and intel
174   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
175   #then   then
176   #export SPECIALDEVICE="zotac_nvidia"   export SPECIALDEVICE="zotac_nvidia"
177   #else   else
178   #export SPECIALDEVICE="zotac_intel"   export SPECIALDEVICE="zotac_intel"
179   #fi   fi
180   #fi   fi
181    
182   # check for special devices/clients:   # check for special devices/clients:
183   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 318  run_hardware_detection_disks() Line 213  run_hardware_detection_disks()
213   # all disks but exclude ramdisks   # all disks but exclude ramdisks
214   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
215   # remove the boot device from ALL_DISKS if it was an usbstick   # remove the boot device from ALL_DISKS if it was an usbstick
216   if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]   if [[ $(grep '[[:space:]]${LIVEROOT}[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
217   then   then
218   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"   bootdev=$(grep "[[:space:]]${LIVEROOT}[[:space:]]" /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')
219   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
220   fi   fi
221   export ALL_CDROMS="$(get_hwinfo cdrom)"   export ALL_CDROMS="$(get_hwinfo cdrom)"
222  }  }
223    
224  setup_hdd_partitions_auto()  setup_hdd_partitions()
225  {  {
  ROOTHDD="${HDD}1"  
   
226   # sanity check - should not happen   # sanity check - should not happen
227   if is_mounted --device "${ROOTHDD}"   if is_mounted --device "${ROOTHDD}"
228   then   then
229   echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2   echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
230   umount "${ROOTHDD}"   umount "${ROOTHDD}"
231   fi   fi
232     if [[ -n ${BOOTHDD} ]]
  # run this only if FDISKPARTITIONBELOW256MB is not already 1  
  if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]  
233   then   then
234   if hdd_size_below_256mb ${HDD}   if is_mounted --device "${BOOTHDD}"
235   then   then
236   FDISKPARTIONBELOW256MB=1   echo "partition: device ${BOOTHDD} is already mounted, umount it" >&2
237   else   umount "${BOOTHDD}"
  FDISKPARTIONBELOW256MB=0  
238   fi   fi
239   fi   fi
240    
241   ## delete disk   if [[ ${INSTALL_METHOD} = auto ]]
  dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die  
   
  if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]  
242   then   then
243   ## setup one bootable partition   # run this only if FDISKPARTITIONBELOW256MB is not already 1
244   #1. n= new disk   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
245   #2. p= primary disk   then
246   #3. 1= first partition   if device_minimum_size "${HDD}" 256
247   #4. 2= default sector start // small disk needs more space for grub2 mbr sector   then
248   #5. ''= defaul sector end   FDISKPARTIONBELOW256MB=1
249   #6. a= bootable flag   else
250   #7. 1= boot flag for partition 1   FDISKPARTIONBELOW256MB=0
251   #8. w= write/quit   fi
252   fdisk ${HDD} &> /dev/null << EOF   fi
253    
254     ## delete disk
255     dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
256    
257     if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
258     then
259     ## setup one bootable partition
260     #1. n= new disk
261     #2. p= primary disk
262     #3. 1= first partition
263     #4. 2= default sector start // small disk needs more space for grub2 mbr sector
264     #5. ''= defaul sector end
265     #6. a= bootable flag
266     #7. 1= boot flag for partition 1
267     #8. w= write/quit
268     fdisk ${HDD} &> /dev/null << EOF
269  n  n
270  p  p
271  1  1
# Line 372  a Line 275  a
275  1  1
276  w  w
277  EOF  EOF
278   else   else
279   ## setup one bootable partition   ## setup one bootable partition
280   #1. n= new disk   #1. n= new disk
281   #2. p= primary disk   #2. p= primary disk
282   #3. 1= first partition   #3. 1= first partition
283   #4. ''= default sector start   #4. ''= default sector start
284   #5. ''= defaul sector end   #5. ''= defaul sector end
285   #6. a= bootable flag   #6. a= bootable flag
286   #7. 1= boot flag for partition 1   #7. 1= boot flag for partition 1
287   #8. w= write/quit   #8. w= write/quit
288   fdisk ${HDD} &> /dev/null << EOF   fdisk ${HDD} &> /dev/null << EOF
289  n  n
290  p  p
291  1  1
# Line 392  a Line 295  a
295  1  1
296  w  w
297  EOF  EOF
298     fi
299     else
300     cfdisk ${HDD} || dialog_die
301   fi   fi
302  }  }
303    
 setup_hdd_partitions_manual()  
 {  
  ROOTHDD="${HDD}1"  
  SWAPHDD=""  
  BOOTHDD=""  
  cfdisk ${HDD} || dialog_die  
 }  
   
304  setup_hdd_format()  setup_hdd_format()
305  {  {
306   # sanity check - should not happen   install -d /tmp
307   if is_mounted --device "${ROOTHDD}"   :> /tmp/format.log
308    
309     if [[ -n ${SWAPHDD} ]]
310   then   then
311   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2   # sanity check - should not happen
312   umount "${ROOTHDD}"   if is_mounted --device "${SWAPHDD}"
313     then
314     echo "format: device ${SWAPHDD} is already mounted, umount it" >&2
315     umount "${SWAPHDD}"
316     fi
317     mkswap ${SWAPHDD} || die
318   fi   fi
319    
320   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die   if [[ -n ${BOOTHDD} ]]
321  }   then
322     # sanity check - should not happen
323     if is_mounted --device "${BOOTHDD}"
324     then
325     echo "format: device ${BOOTHDD} is already mounted, umount it" >&2
326     umount "${BOOTHDD}"
327     fi
328    
329  install_mount_rootfs()   mkfs."${FORMAT_FILESYSTEM_BOOTHDD}" "${BOOTHDD}" &>> /tmp/format.log || dialog_die
330  {   fi
331   is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"  
332   install -d ${INSTALLROOT}/boot || dialog_die   if [[ -n ${ROOTHDD} ]]
333     then
334     # sanity check - should not happen
335     if is_mounted --device "${ROOTHDD}"
336     then
337     echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
338     umount "${ROOTHDD}"
339     fi
340    
341     mkfs."${FORMAT_FILESYSTEM_ROOTHDD}" "${ROOTHDD}" &>> /tmp/format.log || dialog_die
342     fi
343  }  }
344    
345  install_system_image()  install_system_image()
346  {  {
347   pushd ${INSTALLROOT} > /dev/null   pushd ${INSTALLROOT} > /dev/null
348   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}   tar xvjpf ${IMAGEROOT}/${CDIMAGENAME} -C ${INSTALLROOT}
349   popd > /dev/null   popd > /dev/null
350  }  }
351    
# Line 435  install_system_settings() Line 356  install_system_settings()
356   # write fstab   # write fstab
357   CONFIG="${INSTALLROOT}/etc/fstab"   CONFIG="${INSTALLROOT}/etc/fstab"
358   clearconfig   clearconfig
359   addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"   if [[ -n ${BOOTHDD} ]]
360     then
361     addconfig -e "UUID=$(get_uuid ${BOOTHDD})\t/\t${FORMAT_FILESYSTEM_BOOTHDD}\tnoatime\t1 1"
362     fi
363     if [[ -n ${ROOTHDD} ]]
364     then
365     addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM_ROOTHDD}\tnoatime\t0 0"
366     fi
367     if [[ -n ${SWAPHDD} ]]
368     then
369     addconfig -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0"
370     fi
371   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
372   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
373    
# Line 446  install_system_settings() Line 378  install_system_settings()
378   addconfig 'NETWORKING="dhcp"'   addconfig 'NETWORKING="dhcp"'
379    
380   # intel framebuffer quirk   # intel framebuffer quirk
381   if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]   CONFIG="${INSTALLROOT}/etc/splash/splash.conf"
382     if [ -e ${CONFIG} ] && [ -e /proc/fb ]
383   then   then
384   if [ -e /proc/fb ]   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
385   then   then
386   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
387   then   [[ ${fbdev} != 0 ]] && sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${CONFIG} || dialog_die
  fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')  
  if [[ ${fbdev} != 0 ]]  
  then  
  sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die  
  fi  
  fi  
388   fi   fi
389   fi   fi
390  }  }
391    
392  install_umount_rootfs()  
393    ### installer dialogs ###
394    
395    dialog_die()
396  {  {
397   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot   ERROR="$1"
398   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}   RETVAL="$?"
399     dialog_install_failure
400     exit 1
401  }  }
402    
403  install_do_reboot()  dialog_warning()
404  {  {
405   reboot   local retval
406    
407     yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
408     retval=$?
409     if [[ ${retval} -eq 1 ]]
410     then
411     clear
412     echo $"The process was aborted."
413     exit 1
414     fi
415  }  }
416    
 #################################################  
 #     Install Ablauf Scripte #  
 #################################################  
417    
418  run_install_normal()  ### installer tasks ###
419    
420    task_setup_system_menu()
421  {  {
422   task_hardware_detection   local mode
423     local retval
424    
425   task_setup_hdd_partitions_manual   mode="$(dialog_setup_system_menu)"
426   dialog_setup_hdd_format   retval=$?
427   setup_hdd_format > /dev/null   [[ ${retval} -eq 1 ]] && return 1
428   install_mount_rootfs   if [[ ${retval} -eq 0 ]]
429   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   then
430     case "${mode}" in
431     "1") run_install auto ;;
432     "2") run_install normal ;;
433     "") task_setup_system_menu;;
434     esac
435     fi
436    }
437    
438   dialog_install_settings  task_hardware_detection()
439   sleep 1  {
440   install_system_settings   local message
441   if is_initrd_supported  
442     run_hardware_detection_disks
443    
444     message+=$"Harddrives:\n"
445    
446     if [[ ! -z ${ALL_DISKS} ]]
447   then   then
448   dialog_install_initrd   for i in ${ALL_DISKS}
449   initrd_config   do
450   initrd_install   message+="\Z3${i}\Zn "
451     done
452     message+="\n"
453   fi   fi
454    
455   dialog_install_bootsector   if [[ ! -z ${ALL_CDROMS} ]]
456   bootloader_config   then
457   bootloader_install   message+="\n"
458     message+=$"Optical disk drives:\n"
459     for i in ${ALL_CDROMS}
460     do
461     message+="\Z3${i}\Zn"
462     done
463     message+="\n"
464     fi
465    
466   install_umount_rootfs   # other devices
467   dialog_install_successful   run_hardware_detection
468     case "${SPECIALDEVICE}" in
469     zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
470     rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
471     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
472     *) message+=$"\n\ZnCommon device detected.\Zn" ;;
473     esac
474     if [[ ${FORMFACTOR} = laptop ]]
475     then
476     message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
477     fi
478    
479     messagebox -y 12 -h $"Detected hardware:" "${message}"
480    }
481    
482    task_setup_hdd_partitions()
483    {
484     local i
485     local retval
486    
487     if [[ -z ${ALL_DISKS} ]]
488     then
489     dialog_no_harddrive_found
490     exit 1
491     else
492     HDD=$(dialog_select_target_harddrive)
493     retval=$?
494     [[ ${retval} -eq 1 ]] && return 1
495     if [[ ${retval} -eq 0 ]]
496     then
497     dialog_setup_hdd_info
498     setup_hdd_partitions
499     fi
500     fi
501  }  }
502    
503  run_install_auto()  task_main()
504  {  {
505     local method=0
506     local retval
507    
508     while [[ ${method} -le 2 ]]
509     do
510     method=$(dialog_main)
511     retval=$?
512     [[ ${retval} -eq 1 ]] && exit 1
513     if [[ ${retval} -eq 0 ]]
514     then
515     case ${method} in
516     "1") task_setup_system_menu ;;
517     "2") task_hardware_detection ;;
518     "3") install_do_reboot ;;
519     "4") /bin/bash --login -i ;;
520     esac
521     fi
522     done
523    }
524    
525    run_install()
526    {
527     local method="$1"
528    
529   task_hardware_detection   task_hardware_detection
530    
531   task_setup_hdd_partitions_auto   case "${method}" in
532     auto)
533     export BOOTHDD=""
534     export SWAPHDD=""
535     export ROOTHDD="${HDD}1"
536     export FORMAT_FILESYSTEM_BOOTHDD=""
537     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
538     export INSTALL_METHOD="${method}"
539     ;;
540     normal)
541     export BOOTHDD="${HDD}1"
542     export SWAPHDD="${HDD}2"
543     export ROOTHDD="${HDD}3"
544     export FORMAT_FILESYSTEM_BOOTHDD="${FORMAT_FILESYSTEM}"
545     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
546     export INSTALL_METHOD="${method}"
547     ;;
548     single)
549     export BOOTHDD=""
550     export SWAPHDD=""
551     export ROOTHDD="${HDD}1"
552     export FORMAT_FILESYSTEM_BOOTHDD=""
553     export FORMAT_FILESYSTEM_ROOTHDD="${FORMAT_FILESYSTEM}"
554     export INSTALL_METHOD="${method}"
555     ;;
556     flash)
557     export BOOTHDD="${HDD}1"
558     export SWAPHDD=""
559     export ROOTHDD="${HDD}2"
560     export FORMAT_FILESYSTEM_BOOTHDD="${FORMAT_FILESYSTEM}"
561     export FORMAT_FILESYSTEM_ROOTHDD="f2fs"
562     export INSTALL_METHOD="${method}"
563     ;;
564     *)
565     die "Unknown install method '${method}', aborting."
566     ;;
567     esac
568    
569     task_setup_hdd_partitions
570   dialog_setup_hdd_format   dialog_setup_hdd_format
571   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
572   install_mount_rootfs   mount_rootfs
573   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
574    
575   dialog_install_settings   dialog_install_settings
# Line 529  run_install_auto() Line 586  run_install_auto()
586   bootloader_config   bootloader_config
587   bootloader_install   bootloader_install
588    
589   install_umount_rootfs   umount_rootfs
590   dialog_install_successful   dialog_install_successful
591  }  }
592    

Legend:
Removed from v.2481  
changed lines
  Added in v.2889